""" Function manglers for math functions in C++ """

from dune.perftool.generation import (function_mangler,
                                      include_file,
                                      post_include
                                      )

from loopy import CallMangleInfo

import numpy as np


def using_std_statement(name):
    post_include("using std::{};".format(name), filetag="operatorfile")


@function_mangler
def dune_math_manglers(kernel, name, arg_dtypes):
    if name == "exp":
        dt = arg_dtypes[0]
        using_std_statement(name)
        include_file("dune/perftool/common/vectorclass.hh", filetag="operatorfile")
        return CallMangleInfo("exp",
                              arg_dtypes,
                              arg_dtypes,
                              )

    if name == "sqrt":
        dt = arg_dtypes[0]
        using_std_statement(name)
        return CallMangleInfo("sqrt",
                              arg_dtypes,
                              arg_dtypes,
                              )

    if name == "max":
        dt = arg_dtypes[0]
        using_std_statement(name)
        return CallMangleInfo("max",
                              (dt,),
                              arg_dtypes,
                              )

    if name == "min":
        dt = arg_dtypes[0]
        using_std_statement(name)
        return CallMangleInfo("min",
                              (dt,),
                              arg_dtypes,
                              )
